%Length of arms in meter
l1 = 0.11791; % distance between joint 1 and 2
l2 = 0.133;   % distance between joint 2 and 3 in y direction
b1 = 0.05;    %offset
l3 = 0.150;   % distance between joint 3 and 4
l4 = 0.150;%0.147575;  distance between joint 4 and end effector
%Chosen position in radian
q1 = 0;
q2 = 0;
q3 = 0;
q4 = 0;

syms q1 q2 q3 q4 
%DH representation for 4 joint with offset
A1 = [cos(q1) 0 sin(q1) 0; sin(q1) 0 -cos(q1) 0; 0 1 0 l1+l2; 0 0 0 1];
A2 = [cos(q2) -sin(q2) 0 (b1)*cos(q2); sin(q2) cos(q2) 0 (b1)*sin(q2); 0 0 1 0; 0 0 0 1];
A3 = [cos(q3) -sin(q3) 0 l3*cos(q3); sin(q3) cos(q3) 0 l3*sin(q3); 0 0 1 0; 0 0 0 1];
A4 = [cos(q4) -sin(q4) 0 l4*cos(q4); sin(q4) cos(q4) 0 l4*sin(q4); 0 0 1 0; 0 0 0 1];

%Homogeneous transfer function
H_symb = A1 * A2 * A3 * A4;

%End effector coordinate point
xe = H_symb(1,end);
ye = H_symb(2,end);
ze = H_symb(3,end);

% In order to get symbolic expression
xe_subs = subs(xe,[q1 q2 q3 q4]);
ye_subs = subs(ye,[q1 q2 q3 q4]);
ze_subs = subs(ze,[q1 q2 q3 q4]);

% In order to get real coordinate value
% xe_subs = subs(xe);
% ye_subs = subs(ye);
% ze_subs = subs(ze);
% 
% xe_pos = double(xe_subs);
% ye_pos = double(ye_subs);
% ze_pos = double(ze_subs);

disp(xe)
disp(ye)
disp(ze)


