function J = objfun_ik_dh(q,p_eff)
% Joint angles
q1 = q(1);
q2 = -q(2); % minus sign Due to servo characteristic
q3 = -q(3); % minus sign Due to servo characteristic
q4 = q(4);
% Equation for xyz coordinate frame
xe = (cos(q1)*cos(q2))/20 + (3*cos(q4)*(cos(q1)*cos(q2)*cos(q3) - cos(q1)*sin(q2)*sin(q3)))/20 - (3*sin(q4)*(cos(q1)*cos(q2)*sin(q3) + cos(q1)*cos(q3)*sin(q2)))/20 + (3*cos(q1)*cos(q2)*cos(q3))/20 - (3*cos(q1)*sin(q2)*sin(q3))/20;
 
ye = (cos(q2)*sin(q1))/20 - (3*cos(q4)*(sin(q1)*sin(q2)*sin(q3) - cos(q2)*cos(q3)*sin(q1)))/20 - (3*sin(q4)*(cos(q2)*sin(q1)*sin(q3) + cos(q3)*sin(q1)*sin(q2)))/20 - (3*sin(q1)*sin(q2)*sin(q3))/20 + (3*cos(q2)*cos(q3)*sin(q1))/20;
 
ze = sin(q2)/20 + (3*cos(q2)*sin(q3))/20 + (3*cos(q3)*sin(q2))/20 + (3*cos(q4)*(cos(q2)*sin(q3) + cos(q3)*sin(q2)))/20 + (3*sin(q4)*(cos(q2)*cos(q3) - sin(q2)*sin(q3)))/20 + 1/4;
 
xe_hat = p_eff(1);
ye_hat = p_eff(2);
ze_hat = p_eff(3);

ex = (xe_hat) - (xe);
ey = (ye_hat) - (ye);
ez = (ze_hat) - (ze);
e = [ex;ey;ez];
Q =  diag([0.000999,0.000999,0.000999]); % Weighting matrix (Diagonal)
%Objective function
J = e'*Q*e;