%function Qs = optimization_ik_dh
% clc 
% clear

%Waypoint
p2=[0.35;0;0.25];p3=[0.36;0.15;0.20];p4=[0.35;0.15;0.05];p5=[0.28;-0.35;0.2];%p6=[0.35;0;0.25];p7=[0.25;0.25;0.1];p8=[0.3;-0.3;0.25];


%Waypoint velocities


v2=[0;0;0];v3=[0;0;0];v4=[0;0;0];v5=[0;0;0];%v6=[0;0;0];v7=[0;0;0];v8=[0;0;0];v9=[0;0;0];

wayPoints=[p2,p3,p4,p5];%,p6,p7,p8];%,p8];
wayPointVels = [v2,v3,v4,v5];%,v6,v7,v8];%,v8];
wayPointTime = [1;2;6;8];%;10;12;14];%;32;38];

%Time vector for trajectory with 0.1 sec sampling time
trajTime= 0:0.1:wayPointTime(end);

%Creating trajectory using cubic polynomial
trajectory = cubicpolytraj(wayPoints,wayPointTime,trajTime,'VelocityBoundaryCondition',wayPointVels);



%p_eff = trajectory(:,1:121);
p_eff = trajectory(:,1:81);
q_ini = [0.0; 0.0; 0.0; 0.0];

%ops = optimset('Algorithm','sqp','Display','off','MaxIter',1500);
%ops =optimset('Algorithm','interior-point','Display','off','MaxIter',5000);
%ops = optimset('Algorithm','active-set','Display','off','MaxIter',5000);
%ops = optimset('Algorithm','trust-region-reflective','Display','off','MaxIter',1500);
%ops = optimoptions(@lsqnonlin,'Algorithm','levenberg-marquardt','MaxFunctionEvaluations',1500);
%ops = optimset('PlotFcns','optimplotfval','TolX',1e-7);


%define the function where the objective function will be calculated
%define the function where the nonlinear constraints will be
%calculated (both equality and inequality constraints will be calculated in
ops = optimset('Algorithm','sqp','Display','off','MaxIter',1500);
lb = [-1.57; -1.57; -1.57; -1.57]; % Lower bound in radian
ub = [1.57; 1.57; 1.57; 1.57]; % Upper bound in radian
q_ik = zeros(61,4);
elapsed_time = zeros(81,1);
for i= 1:81
 tic  
 obj_func = @(q)objfun_ik_dh(q,p_eff(:,i));
 
%use the fmincon solver
[q,fval,exitflag,output,solutions] = fmincon(obj_func,q_ini,[],[],[],[],lb,ub,[],ops);
  q_ik(i,:) = q;
  q_ini = q;
  elapsed_time(i,1)= toc;
 end

[xe_check,ye_check,ze_check] = test_fk(q_ik);
xe_org = trajectory(1,:);
ye_org = trajectory(2,:);
ze_org = trajectory(3,:);
figure,
plot3(xe_check,ye_check,ze_check,'o',xe_org,ye_org,ze_org,'x')
legend('Check','Original')
grid on


% hold on
% plot3(xe_org,ye_org,ze_org);
% legend('Original')
% grid on
% hold off

u = 0:0.1:8;%zeros (121,1);

% %Convert q_ik to timeseries data
Qs = timeseries(q_ik,u);

% In order to use q_ik value in hardware Qs need to be in data format
%M = Qs.Data; %Inside M variable sampling time0.1s should be added manually 
%P = M(:,1:2); % P is used as joint angle q1 which can be replaced with V 
%Q = M(:,[1 3]); % Q is used as joint angle q2 which can be replaced with X
%R = M(:,[1 4]); % R is used as joint angle q3 which can be replaced with Y
%S = M(:,[1 5]); % S is used as joint angle q4 which can be replaced with Z

% figure,
% plot(elapsed_time);
disp (q_ik)

 